/* main.c
 *
 * skoosh - a simple sliding tile puzzle for the GNOME Desktop
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * http://www.gnu.org/copyleft/gpl.html
 *
 */



#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "support.h"
#include "puzzle.h"
#include "interface.h"
#include "prefs.h"


#define IMAGE_SIZE   300


Puzzle *puzzle = NULL;
gint image_px;


static gboolean double_size = FALSE;
static const struct poptOption opts[] = {
        {
                "double-size", 'd',
                POPT_ARG_NONE,
                &double_size, 0,
                N_("Scale graphics to twice normal size"),
                NULL
        },
        { NULL, '\0', 0, NULL, 0 }
};



int
main (int argc, char *argv[])
{
#ifdef ENABLE_NLS
        bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
        bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
        textdomain (GETTEXT_PACKAGE);
#endif

        gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                            argc, argv,
                            GNOME_PARAM_POPT_TABLE, opts,
                            GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                            NULL);

        image_px = double_size ? IMAGE_SIZE * 2 : IMAGE_SIZE;

        puzzle = puzzle_new ();
        prefs_init (argc, argv);
        create_app ();

        gtk_main ();

        exit (0);
}

