/* puzzle.h */



#define IS_MISSING(t) (tile_get_missing (t) == TRUE)
#define IS_SOLVED(p)  (puzzle_get_solved (p) == TRUE)
#define IS_RANDOM(p)  (puzzle_get_random (p) == TRUE)


typedef struct _Puzzle Puzzle;
typedef struct _Tile   Tile;


Puzzle*  puzzle_new (void);
void     puzzle_free (Puzzle *p);

void     puzzle_new_game (Puzzle *p);

void     puzzle_set_size (Puzzle *p, gint size);
gint     puzzle_get_size (Puzzle *p);
gint     puzzle_get_tile_px (Puzzle *p);

void     puzzle_check_state (Puzzle *p);
void     puzzle_set_solved (Puzzle *p, gboolean solved);
gboolean puzzle_get_solved (Puzzle *p);
  
void     puzzle_clear_moves (Puzzle *p);
void     puzzle_incr_moves (Puzzle *p);
gint     puzzle_get_moves (Puzzle *p);

void     puzzle_set_random (Puzzle *p, gboolean random);
gboolean puzzle_get_random (Puzzle *p);

void     puzzle_create_tiles (Puzzle *p);
void     puzzle_reset_tiles (Puzzle *p);
void     puzzle_shuffle_tiles (Puzzle *p);
void     puzzle_display_tiles (Puzzle *p);

gboolean puzzle_move_tile (Puzzle *p, gint x, gint y);
Tile*    puzzle_get_tile (Puzzle *p, gint x, gint y);

gboolean tile_get_missing (Tile *t);
void     tile_set_missing (Tile *t, gboolean missing);
gint     tile_get_x (Tile *t);
gint     tile_get_y (Tile *t);


